﻿using Infragistics.Controls.Menus;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Interactivity;

namespace XamDataTreeEditModeCase
{
    public class TreeNodeEditBehavior : Behavior<XamDataTree>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.InitializeNode += AssociatedObjectOnInitializeNode;
        }

        protected override void OnDetaching()
        {
            AssociatedObject.InitializeNode -= AssociatedObjectOnInitializeNode;
            base.OnDetaching();
        }

        private void AssociatedObjectOnInitializeNode(object sender, InitializeNodeEventArgs e)
        {
            var tree = sender as XamDataTree;

            if (e.Node.Data is ChildData)
            {

                var nodeData = e.Node.Data as ChildData;
                if (tree != null && nodeData != null)
                {
                    tree.EnterEditMode(e.Node);
                }
            }
        }
    }
}
