﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDataTreeEditModeCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        public NodeBase ActiveNode { get; set; }

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < 10; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Label = "Parent Label " + i.ToString()
                });
            }

            ActiveNode = Data[2];
        }
    }

    public class SampleData : NodeBase
    {

        public string Label { get; set; }
        public int ID { get; set; }

        public ObservableCollection<ChildData> Children { get; set; }

        public SampleData()
        {
            Children = new ObservableCollection<ChildData>();

            for (int i = 0; i < 2; i++)
            {
                Children.Add(new ChildData()
                {
                    ChildID = i,
                    ChildLabel = "Child Label " + i.ToString()
                });
            }
        }
    }

    public class ChildData : NodeBase
    {
        public string ChildLabel { get; set; }
        public int ChildID { get; set; }
    }

    public interface NodeBase
    {

    }
}
